<template>
  <section class="ocw">
    <template v-if="now">
      <svg
          class="ocw__condition"
          :style="{width: `${currentStyles.fontSize / 87.5}rem`, height: `${currentStyles.fontSize / 87.5}rem`}"
      >
        <use :xlink:href="`#${now.condition_code}`"></use>
      </svg>
      <div class="ocw__temperature">
        <!-- TODO: Use optional chaining once transpiling templates -->
        <span>{{ now.temperature && now.temperature.toFixed(1) }}</span><span
          class="ocw__unit">{{ now.hasImperialUnit ? "°F" : "°C" }}</span>
      </div>

      <div class="ocw__humidity">
        <!-- FIXME: Load SVGs from asset file once compilation is supported -->
        <svg
            class="ocw__icon"
            :style="{width: `${currentStyles.fontSize * 0.0035}rem`}"
            version="1.1"
            xmlns="http://www.w3.org/2000/svg"
            xmlns:xlink="http://www.w3.org/1999/xlink"
            x="0px"
            y="0px"
            viewBox="0 0 363.4 363.4"
            xml:space="preserve"
            fill="currentColor"
        >
              <path
                  d="M133.9,86.1C133.9,53.6,86.1,0,86.1,0S38.3,53.5,38.3,86.1c0,24.9,15.3,47.8,47.8,47.8S133.9,109.1,133.9,86.1z M86,114.8
      c-13.4,0-28.7-5.7-28.7-28.7C57.3,67,86,30.6,86,30.6s28.7,36.3,28.7,55.5C114.7,109.1,99.4,114.8,86,114.8z"
              />
          <path
              d="M277.3,76.6c0,0-47.8,53.5-47.8,86.1c0,24.9,15.3,47.8,47.8,47.8s47.8-24.899,47.8-47.8
      C325.1,130.1,277.3,76.6,277.3,76.6z M277.3,191.3c-13.4,0-28.7-5.699-28.7-28.7c0-19.1,28.7-55.5,28.7-55.5s28.7,36.3,28.7,55.5
      C306,185.601,290.7,191.3,277.3,191.3z"
          />
          <path
              d="M95.6,315.601c0,24.899,15.3,47.8,47.8,47.8s47.8-24.9,47.8-47.8c0-32.5-47.8-86.101-47.8-86.101
      S95.6,283.101,95.6,315.601z M143.4,344.3c-13.4,0-28.7-5.699-28.7-28.699c0-19.101,28.7-55.5,28.7-55.5s28.7,36.3,28.7,55.5
      C172.1,338.601,156.8,344.3,143.4,344.3z"
          />
          </svg>
        {{ now.humidity }}%
      </div>

      <div class="ocw__pop">
        <svg version="1.1"
             class="ocw__icon"
             :style="{width: `${currentStyles.fontSize * 0.0035}rem`}"
             xmlns="http://www.w3.org/2000/svg"
             xmlns:xlink="http://www.w3.org/1999/xlink"
             viewBox="0 0 555.166 555.166"
             xml:space="preserve"
        >
	<path d="M294.202,61.183V48.759c0-9.18-7.439-16.619-16.619-16.619c-9.18,0-16.619,7.439-16.619,16.619v12.424
		C122.217,68.187,10.839,162.279,0,280.646c13.491-9.683,33.959-15.864,56.882-15.864c35.673,0,65.396,14.96,72.121,34.81h2.958
		c6.896-19.721,36.53-34.551,72.046-34.551c22.991,0,43.466,6.236,56.957,15.966v166.668c0,23.216-18.891,42.105-42.105,42.105
		c-23.215,0-42.106-18.89-42.106-42.105c0-9.18-7.439-16.619-16.619-16.619c-9.18,0-16.619,7.439-16.619,16.619
		c0,41.548,33.803,75.352,75.351,75.352c41.548,0,75.337-33.804,75.337-75.352V280.735c13.484-9.724,33.952-15.953,56.93-15.953
		c35.673,0,65.396,14.96,72.121,34.81h2.958c6.895-19.721,36.529-34.551,72.046-34.551c22.937,0,43.418,6.188,56.909,15.885
		C544.477,162.428,433.045,68.201,294.202,61.183z"/>
</svg>

        {{ (now.pop * 100).toFixed(0) }}%
      </div>

      <div class="ocw__wind">
        <svg
            :style="{width: `${currentStyles.fontSize * 0.0035}rem`}"
            version="1.1"
            viewBox="0 0 28.35 28.35"
            fill="currentColor"
            class="ocw__icon"
        >
          <g>
            <path
                d="M5.394,14.763c0,0.244,0.152,0.466,0.38,0.552l14.713,5.593c0.064,0.025,0.134,0.038,0.204,0.038
  c0.19,0,0.376-0.094,0.483-0.244c0.152-0.21,0.144-0.518-0.02-0.717l-4.257-5.222l0.051-0.063l4.204-5.157
  c0.164-0.199,0.174-0.507,0.021-0.716c-0.11-0.153-0.289-0.245-0.478-0.245c-0.071,0-0.143,0.013-0.21,0.039L5.772,14.214
  C5.545,14.298,5.394,14.519,5.394,14.763z M7.704,14.74l11.146-4.236l-0.059,0.072l-3.11,3.816
  c-0.173,0.208-0.173,0.535-0.001,0.744l3.169,3.887l-0.087-0.033l-1.92-0.728l-9.199-3.499L7.704,14.74z"
                :transform="`rotate(${now.wind_angle}, 14.175, 14.175)`"
            />
          </g>
        </svg>

        {{ now.wind_speed }}<span class="ocw__wind-unit">{{ now.hasImperialUnit ? "mph" : "m/s" }}</span>
      </div>
    </template>
  </section>
</template>

<script>
module.exports = {
  name: "owm-current-weather",
  props: {
    currentSettings: {
      type: Object,
      required: true,
    },
    currentDimensions: {
      type: Object,
      required: false
    },
    currentStyles: {
      type: Object,
      required: true,
    },
    records: {
      type: Array,
      required: false
    },
    language: {
      type: String,
      required: true
    },
    locale: {
      type: String,
      required: true
    },
    backendUrl: {
      type: String,
      required: true
    },
    fetchAsset: {
      type: Function,
      required: false
    },
  },
  computed: {
    /**
     * Gets the current entry from the array of forecast time slices.
     * @typedef {object} CurrentWeatherEntry
     * @property {number} temperature
     * @property {number} humidity
     * @property {number} wind_speed
     * @property {number} wind_angle
     * @property {string} condition_code
     * @property {('metric'|'imperial')} unit
     * @returns {(CurrentWeatherEntry|undefined)} The conditions for the current time period, or undefined.
     */
    now: function () {
      return this.records[0] && this.records[0].attributes.entries[0];
    },
    hasImperialUnit() {
      return this.now && this.now.unit === 'imperial';
    }
  },
};
</script>

<style>
.ocw {
  display: grid;
  grid-template-areas: "condition-icon temperature temperature"
  "humidity pop wind";
  row-gap: 10%;
  column-gap: 2.5%;
  grid-template-columns: min-content min-content;
  grid-auto-rows: min-content;
  white-space: nowrap;
}

.ocw__condition {
  grid-area: condition-icon;
}

.ocw__temperature {
  grid-area: temperature;
  line-height: 0.6;
  letter-spacing: -0.125rem;
  text-align: right;
}

.ocw__unit {
  font-size: 40%;
  line-height: 0.7;
  vertical-align: top;
  letter-spacing: initial;
}

.ocw__icon {
  vertical-align: middle;
}

.ocw__humidity, .ocw__pop, .ocw__wind {
  font-size: 30%;
}

.ocw__humidity {
  grid-area: humidity;
}

.ocw__pop {
  grid-area: pop;
}

.ocw__wind {
  grid-area: wind;
}

.ocw__wind-unit {
  font-size: 50%;
  margin-left: -0.125em;
}

.font-inter .ocw__unit {
  line-height: 0.9;
}

.font-inter .ocw__temperature {
  line-height: 0.8;
}
</style>
